#ifndef _INCLUDE_CFG_MEMORY_H_
#define _INCLUDE_CFG_MEMORY_H_

/*
 * NUTMEM_START and NUTMEM_SIZE must be defined
 * if an extra RAM area should be used for the heap.
 * If both are not defined, the heap will be used 
 * from the "normal" data area.
 */
#if defined(ALTERA_DE1) || defined(ALTERA_DE2) 
#ifndef NUTMEM_START
#define NUTMEM_START    SDRAM_BASE
#endif

#ifndef NUTMEM_SIZE
#define NUTMEM_SIZE     SDRAM_SPAN
#endif
#endif

#if defined(ALTERA_DE0_NANO)
#define NUTMEM_SIZE     SDRAM_SPAN
#endif


/*
 * Define the stack size in bytes of the threads
 * which are used in the system.
 */
#define NUT_THREAD_STACK_MULT    1

/*
 * Define if stack check function should be used.
 */
#define NUTDEBUG_CHECK_STACK     1     

/*
 * System stacks
 */

/* Idle and main thread */
#define NUT_THREAD_IDLESTACK     1024
#define NUT_THREAD_MAINSTACK     2048

/* TCP state machine */
#define NUT_THREAD_TCPSMSTACK    1024

/* Ethernet RX thread */
#define NUT_THREAD_NICRXSTACK    1024


/*
 * Application stacks
 */

/* http service thread */
#define HTTPD_SERVICE_STACK      2048
#define UPNP_SERVICE_STACK       2048
#define NUT_THREAD_DHCPSTACK     2048

#define NUT_THREAD_DISTSTACK     2048
#define NUT_THREAD_SNTPSTACK     2048
#define NUT_THREAD_PPPSMSTACK    2048
#define NUT_THREAD_VSCODEC0STACK 2048

#endif
