/****************************************************************************
*  Copyright (C) 2012 by Michael Fischer

*  All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*  
*  1. Redistributions of source code must retain the above copyright 
*     notice, this list of conditions and the following disclaimer.
*  2. Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in the 
*     documentation and/or other materials provided with the distribution.
*  3. Neither the name of the author nor the names of its contributors may 
*     be used to endorse or promote products derived from this software 
*     without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
*  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS 
*  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
*  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF 
*  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
*  SUCH DAMAGE.
*
****************************************************************************/

#ifndef _ARCH_NIOS2_H_
#define _ARCH_NIOS2_H_

#include <cfg/arch.h>
#include <arch/nios2/nios_io.h>

/*!
 * \brief Interrupt entry.
 */
#define IRQ_ENTRY()

/*!
 * \brief Interrupt exit.
 */
#define IRQ_EXIT()


#ifndef CONST
#define CONST     const
#endif

#ifndef INLINE
#define INLINE    inline
#endif

#define PSTR(p)    (p)
#define PRG_RDB(p) (*((const char *)(p)))

#define prog_char  const char
#define PGM_P      prog_char *

#define strcmp_P(x,y)   strcmp((char *)(x), (char *)(y))
#define memcpy_P(x,y,z) memcpy(x, y, z)

#ifndef _NOP
#define _NOP() asm ("nop");
#endif

#define _BV(bit)    ((int)1 << (bit))

#define outb(_reg, _val)   IOWR_8DIRECT(_reg, 0, _val)
#define outw(_reg, _val)   IOWR_16DIRECT(_reg, 0, _val)

#define inb(_reg)          ((uint8_t)IORD_8DIRECT(_reg, 0))
#define inw(_reg)          IORD_16DIRECT(_reg, 0) 

#endif

/*** EOF ***/

